#
# shinGETsu - P2P anonymous BBS
#
# (c) Fuktommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: CacheStat.pm,v 1.12 2004/08/24 16:06:45 fuktommy Exp $
#

package Shingetsu::CacheStat;
use strict;
use Shingetsu::AttachCache;
use Shingetsu::Config;
use Shingetsu::Util;

#
# configration
#
my $datadir  = $Shingetsu::Config::datadir;
my $statfile = $Shingetsu::Config::stat;

#
# get status list
#
sub list() {
	local $_;
	my %stat = ();
	if (open IN, $statfile) {
		while (<IN>) {
			chomp;
			local @_ = split /<>/;
			$stat{$_[0]} = {
					stamp	=> $_[1],
					records	=> $_[2],
					size	=> $_[3],
				};
		}
		close IN;
		return %stat;
	} else {
		return ();
	}
}

#
# sync hash to file
#
sub sync(%) {
	my(%stat) = @_;
	local $_;
	Shingetsu::Util::lock();
	open OUT, "> $statfile" or die "$statfile: open failed. $!";
	my ($k,$v);
	while (($k,$v) = each %stat) {
		next if ((! defined $k) || ($k eq ""));
		foreach ($$v{stamp}, $$v{records}, $$v{size}) {
			$_ = 0 unless (defined $_);
		}
		print OUT "$k<>$$v{stamp}<>$$v{records}<>$$v{size}\n";
	}
	close OUT;
	Shingetsu::Util::unlock();
}

#
# update latest status
#
sub update() {
	my @file = glob "$datadir/*.dat";
	my %stat = ();
	local $_;
	Shingetsu::Util::lock();
	foreach (@file) {
		my %tmp = ();
		my $filename  = $_;
		$filename =~ s|$datadir/||;
		$filename =~ s|\.dat$||;

		my @data = ();
		if (open IN, $_) {
			@data = <IN>;
			close IN;
		}
		if (@data) {
			local @_ = split /<>/, $data[-1], 2;
			$tmp{stamp} = $_[0];
		} else {
			$tmp{stamp} = 0;
		}

		$tmp{records} = @data;
		$tmp{size}    = (-s "$datadir/$filename.dat");
		$stat{$filename} =  {%tmp};

		Shingetsu::AttachCache::update($filename, @data);
	}
	Shingetsu::Util::unlock();
	sync(%stat);
	warn "CacheStat::update() finished\n";
}

1;
