#
# shinGETsu - P2P anonymous BBS
#
# (c) FukTommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: Config.pm,v 1.98 2004/12/18 08:19:32 fuktommy Exp $
#

package Shingetsu::Config;

$port		= 8000;
$debug		= 0;				# boolean
$resolv		= 0;				# boolean
$adminAddr	= "^127";			# regxp
$friendAddr	= ".";				# regxp
$path		= "/server.cgi";
$root		= "/";
$index		= "/gateway.cgi";
$cgiDir		= "./cgi-bin";
$css		= "/default.css";
$umask		= 0000;				# octet
@initNode	= qw(
	shingetsu.xrea.jp:80/node.cgi
	feeling.zive.net:8000/server.cgi
	pushare.zive.net:8000/server.cgi
	fuktommy.ddo.jp:8000/server.cgi
	yanga.s51.xrea.com:80/shingetsu/node.xcg
);

$menufile	= "menu";
$datadir	= "../dat";
$cachedir	= "../cache";
$filedir	= "../file";
$wwwdir		= "../www";
$motd		= "$filedir/motd.txt";
$nodelist	= "$datadir/node.txt";
$updatelist	= "$datadir/update.txt";
$lock		= "$datadir/lock.txt";
$pid		= "$datadir/pid.txt";
$client		= "$datadir/client.txt";
$stat		= "$datadir/stat.txt";
$trust		= "$datadir/trust.txt";
$search		= "$datadir/search.txt";

$timeout	= 30;		# seconds
$timeout_connect=  5;		# seconds
$timeout_client	= 30;		# minutes ( $timeout_client < $syncfrec )
$pingfrec	= 10;		# minutes
$syncfrec	= 60;		# minutes
$initfrec	= 25;		# minutes
$chckfrec	= 180;		# minutes
$clientfrec	= 5;		# minutes
$syncsafety	= 240;		# hours
$saveupdate	= 1440;		# minutes
$savehistory	= 480;		# hours (-1 for infinity)
$saveheader	= 720;		# hours (-1 for infinity)
$timeError	= 60;		# seconds
$retry		= 5;		# times
$retrySearch	= 2;		# times
$askNode	= 5;		# times
$childrenLimit	= 10;
$searchDepth	= 30;
$retryGet	= 3;		# times
$nodes		= 5;
$bufsize	= 8192;		# bytes
$filelimit	= 10;		# mega bytes
$retryUpdate	= 5;		# times
$waitUpdate	= 10;		# seconds
$redirect	= 1;		# boolean
$language	= "en";		# language code (see RFC3066)
$version	= "0.5.4";

$google		= "http://www.google.co.jp/search";
$robot		= "bot|Yahoo";	# regexp

%command = (
	gzip	 => "gzip -c",
	gunzip	 => "gunzip -c",
	md5sum	 => "md5sum",
	uuencode => "uuencode -m",
	uudecode => "uudecode",
	apollo	 => "../contrib/apollo",
);

if ($^O eq "freebsd") {
	$command{md5sum}   = "md5";
	$command{uudecode} = "uudecode -p";
}

@systemFile = qw ( default.css favicon.ico );
@index	    = qw ( index.html index.htm index.txt );

%encoding  = qw (
	gz	gzip
	bz2	bzip2
);

%mimeType = qw (
	avi	video/x-msvideo
	bin	application/octet-stream
	bmp	image/bmp
	cpio	application/x-cpio
	css	text/css
	csv	text/comma-separated-values
	dvi	application/x-dvi
	gif	image/gif
	html	text/html
	ico	image/x-icon
	jar	application/x-java-archive
	jpg	image/jpeg
	lzh	application/x-lzh
	mid	audio/midi
	mov	video/quicktime
	mp3	audio/mpeg
	mpg	video/mpeg
	ogg	application/x-ogg
	pdf	application/pdf
	pgp	application/pgp-signature
	png	image/png
	ps	application/postscript
	ra	audio/x-realaudio
	rpm	application/x-redhat-package-manager
	swf	application/x-shockwave-flash
	tar	application/x-tar
	tex	application/x-tex
	tif	image/tiff
	txt	text/plain
	tgz	application/x-gtar
	wav	audio/x-wav
	xml	text/xml
	zip	application/zip
);

1;
